# Модуль для просмотра ВАХ

PyQt-виджет для отображения ВАХ. Предназначен в первую очередь для встраивания в разные продукты линейки EyePoint. Виджет должен уметь выводить несколько ВАХ на график и при необходимости обновлять их.

## Запуск в Windows

1. Установите зависимости:

   ```batch
   python -m venv venv
   venv\Scripts\python -m pip install --upgrade pip
   venv\Scripts\python -m pip install -r requirements.txt
   ```

2. Запустите пример:

   ```batch
   venv\Scripts\python -m ivviewer
   ```

   или

   ```batch
   venv\Scripts\python example.py
   ```

3. Запустите тесты. Перейдите в папку **scripts** и запустите скрипт **testall.bat**.

   Также вы можете запустить тесты с выводом на экран окна с виджетом. Для этого в командной строке из корня репозитория выполните команду:
   
   ```batch
   venv\Scripts\python -m pytest ivviewer\tests -v --display_window
   ```
   
   Если наведете мышку на окно с виджетом, то сможете увидеть всплывающую подсказку для конкретного теста.

## Запуск в Linux

1. Установите зависимости:

   ```bash
   python3 -m venv venv
   venv/bin/python3 -m pip install --upgrade pip
   venv/bin/python3 -m pip install -r requirements.txt
   ```

2. Запустите пример:

   ```bash
   venv/bin/python3 -m ivviewer
   ```

   или

   ```bash
   venv/bin/python example.py
   ```

3. Запустите тесты. Перейдите в папку **scripts** и запустите скрипт **testall.sh**:

   ```bash
   bash testall.sh
   ```
   
   Также вы можете запустить тесты с выводом на экран окна с виджетом. Для этого в терминале из корня репозитория выполните команду:
   
   ```bash
   venv/bin/python3 -m pytest ivviewer/tests -v --display_window
   ```
   
   Если наведете мышку на окно с виджетом, то сможете увидеть всплывающую подсказку для конкретного теста.

# Выпуск релиза на PyPI

1. Поставьте следующие значения в переменные окружения:

   ```
   TWINE_USERNAME=__token__
   TWINE_PASSWORD=<токен от pypi вместе с префиксом pypi->
   ```
   
   Либо пропишите в файле **.pypirc**, который должен находиться в Вашей домашней директории, следующие строки:
   
   ```
   [pypi]
   username = __token__
   password = <токен от pypi вместе с префиксом pypi->
   ```
2. Перейдите в папку **scripts** и запустите **release.bat**/**release.sh** в зависимости от ОС.

#### Распространенные проблемы с использованием скриптов release.bat/release.sh

- Если возникла ошибка **"AttributeError: version_info object has no attribute '\__version__'"**, версия Python на вашем компьютере устарела и не поддерживает twine и build, необходимые для работы с PyPI. Поставьте более актуальную версию и добавьте её в путь.
- Если возникла ошибка 403, вы неправильно ввели токен. Проверьте, что вы не потеряли префикс, без него авторизация не будет выполнена.
- Если возникла ошибка 400, вы уже загрузили в репозиторий версию с этим номером. К сожалению, PyPI больше не поддерживает замену файлов. Вы можете использовать нумерацию v.v.v-1, v.v.v-2 и т. д. (не рекомендуется) либо загрузить файл, как патч со следующим номером версии.


## Примечания

- Модуль тестировался на Python версии 3.6.
- В системе должны быть установлены Qt5, Qwt.
